// HTMLBuilder.h: interface for the CHTMLBuilder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTMLBUILDER_H__CB40BC70_31B4_11D6_9CD7_444553540000__INCLUDED_)
#define AFX_HTMLBUILDER_H__CB40BC70_31B4_11D6_9CD7_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global/typedefs.h"

class CHTMLBuilder  
{
  public:
                    CHTMLBuilder        (Mythos::MemFile& MemFile);
    virtual        ~CHTMLBuilder        (void);

    void            WriteHeader         (const char* pszFile);
    void            WriteFooter         (void);
    void            Parse               (void);

  protected:

    void            ParseLine           (char* pszLine);
    bool            IsDigit             (const char cChar);
    bool            IsKeyword           (void);
    bool            IsNumber            (void);
    void            PutWord             (void);

  protected:

    Mythos::MemFile&m_MemFile;
    Mythos::File    m_OutputFile;

    bool            m_boCommBlock;
    char            m_szWord[1024];                         // current accumulated word
    DWORD           m_dwWordLen;                            // nb accumulated chars
};

#endif // !defined(AFX_HTMLBUILDER_H__CB40BC70_31B4_11D6_9CD7_444553540000__INCLUDED_)
