//--------------------------------------------------------------------------------------------------------------------//
//                                                MEMORY FILE ACCESS WITH C LIB                                       //
// 13/02/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_MEMFILEC_INL_
#define   _MYTHOS_MEMFILEC_INL_
#pragma    once

//--------------------------------------------------------------------------------------------------------------------//
//                                                CONSTRUCTORS / DESTRUCTOR                                           //
//--------------------------------------------------------------------------------------------------------------------//

INLINE Mythos::CMemFileC::CMemFileC()
  {
  Init();
  }

//

INLINE Mythos::CMemFileC::~CMemFileC()
  {
  DeleteBuffer();
  }

//--------------------------------------------------------------------------------------------------------------------//
//                                                OPERATIONS                                                          //
//--------------------------------------------------------------------------------------------------------------------//

INLINE u32 Mythos::CMemFileC::GetSize()
  {
  if(!m_pu8File) return 0;
  return m_u32Used;
  }

//

INLINE bool Mythos::CMemFileC::Eof() const
  {
  return m_boEOF;
  }

//

INLINE bool Mythos::CMemFileC::Error() const
  {
  return m_boError;
  }

//

INLINE bool Mythos::CMemFileC::Flush()
  {
  return true;
  }

//

INLINE u32 Mythos::CMemFileC::GetChar()
  {
  u32 u32Tmp;
  u32 u32Read = Read(&u32Tmp,1);
  if(!u32Read) return EOF;
  return u32Tmp;
  }

//

INLINE bool Mythos::CMemFileC::PutChar(const u32 u32Char)
  {
  u32 u32Written = Write(&u32Char,1);
  return(u32Written > 0);
  }

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_MEMFILEC_INL_
