//--------------------------------------------------------------------------------------------------------------------//
//                                                MEMORY FUNCTIONS                                                    //
// 15/02/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_MEMC_INL_
#define   _MYTHOS_MEMC_INL_
#pragma    once

//----------------------------------------------- INCLUDES -----------------------------------------------------------//

#include  "Memory/Allocators/Allocator.h"

//--------------------------------------------------------------------------------------------------------------------//

INLINE void* Mythos::CMemC::MemSet(void* pvDest,ui uiChr,u32 u32Count)
  {
  return memset(pvDest,uiChr,u32Count);
  }

//

INLINE void* Mythos::CMemC::MemCpy(void* pvDest,const void* pvSrc,u32 u32Count)
  {
  return memcpy(pvDest,pvSrc,u32Count);
  }

//

INLINE void* Mythos::CMemC::Malloc(u32 u32Size,CAllocator* pAlloc)
  {
  if(pAlloc) return pAlloc->_MALLOC_(u32Size);
  return new u8[u32Size];
  }

//

INLINE bool Mythos::CMemC::Free(void* pvAddr,CAllocator* pAlloc)
  {
  if(!pvAddr) return true;
  if( pAlloc) return pAlloc->Free(pvAddr);
  delete [] pvAddr;
  return true;
  }

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_MEMC_INL_
